using System;
using System.ComponentModel;
using System.IO;
using System.Text;
using System.Windows.Forms;

namespace DictionaryParser {

    public class MainForm : Form {

        private System.Windows.Forms.MainMenu mainMenu;
        private System.Windows.Forms.MenuItem fileMenuItem;
        private System.Windows.Forms.MenuItem parseDictionaryMenuItem;
        private System.Windows.Forms.MenuItem exitMenuItem;
        private System.Windows.Forms.OpenFileDialog openFileDialog;
        private System.Windows.Forms.TextBox dictionaryTextBox;

        private Container components = null;

        public MainForm() {
            InitializeComponent();
        }

        protected override void Dispose(bool disposing) {
            if (disposing) {
                if (components != null) {
                    components.Dispose();
                }
            }
            base.Dispose(disposing);
        }

        #region Windows Form Designer generated code
        /// <summary>
        /// Required method for Designer support - do not modify
        /// the contents of this method with the code editor.
        /// </summary>
        private void InitializeComponent()
        {
            this.mainMenu = new System.Windows.Forms.MainMenu();
            this.fileMenuItem = new System.Windows.Forms.MenuItem();
            this.parseDictionaryMenuItem = new System.Windows.Forms.MenuItem();
            this.exitMenuItem = new System.Windows.Forms.MenuItem();
            this.dictionaryTextBox = new System.Windows.Forms.TextBox();
            this.openFileDialog = new System.Windows.Forms.OpenFileDialog();
            this.SuspendLayout();
            // 
            // mainMenu
            // 
            this.mainMenu.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
                                                                                     this.fileMenuItem});
            // 
            // fileMenuItem
            // 
            this.fileMenuItem.Index = 0;
            this.fileMenuItem.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
                                                                                         this.parseDictionaryMenuItem,
                                                                                         this.exitMenuItem});
            this.fileMenuItem.Text = "File";
            // 
            // parseDictionaryMenuItem
            // 
            this.parseDictionaryMenuItem.Index = 0;
            this.parseDictionaryMenuItem.Text = "Parse dictionary...";
            this.parseDictionaryMenuItem.Click += new System.EventHandler(this.parseDictionaryMenuItem_Click);
            // 
            // exitMenuItem
            // 
            this.exitMenuItem.Index = 1;
            this.exitMenuItem.Text = "Exit";
            this.exitMenuItem.Click += new System.EventHandler(this.exitMenuItem_Click);
            // 
            // dictionaryTextBox
            // 
            this.dictionaryTextBox.BackColor = System.Drawing.SystemColors.Control;
            this.dictionaryTextBox.Dock = System.Windows.Forms.DockStyle.Fill;
            this.dictionaryTextBox.Location = new System.Drawing.Point(0, 0);
            this.dictionaryTextBox.Multiline = true;
            this.dictionaryTextBox.Name = "dictionaryTextBox";
            this.dictionaryTextBox.ScrollBars = System.Windows.Forms.ScrollBars.Vertical;
            this.dictionaryTextBox.Size = new System.Drawing.Size(492, 203);
            this.dictionaryTextBox.TabIndex = 0;
            this.dictionaryTextBox.Text = "";
            // 
            // MainForm
            // 
            this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
            this.ClientSize = new System.Drawing.Size(492, 203);
            this.Controls.Add(this.dictionaryTextBox);
            this.Menu = this.mainMenu;
            this.Name = "MainForm";
            this.Text = "Dictionary parser";
            this.ResumeLayout(false);

        }
        #endregion

        [STAThread]

        static void Main() {
            Application.Run(new MainForm());
        }

        private void parseDictionaryMenuItem_Click(object sender, System.EventArgs e) {
            if (openFileDialog.ShowDialog() == DialogResult.OK) {
                Dictionary dictionary = new Dictionary();
                dictionary.parse(openFileDialog.FileName);
                dictionaryTextBox.AppendText(" : " + Convert.ToString(dictionary.getCount()) + "\r\n");
                dictionaryTextBox.AppendText(" " + dictionary.getWordsFileName()               + ": " + Convert.ToString(dictionary.getWordsFileSize())               + "\r\n");
                dictionaryTextBox.AppendText(" " + dictionary.getDescriptionsFileName()        + ": " + Convert.ToString(dictionary.getDescriptionsFileSize())        + "\r\n");
                dictionaryTextBox.AppendText(" " + dictionary.getWordsOffsetsFileName()        + ": " + Convert.ToString(dictionary.getWordsOffsetsFileSize())        + "\r\n");
                dictionaryTextBox.AppendText(" " + dictionary.getDescriptionsOffsetsFileName() + ": " + Convert.ToString(dictionary.getDescriptionsOffsetsFileSize()) + "\r\n");
                dictionaryTextBox.AppendText(".  : "     + Convert.ToString(dictionary.getMinWordSize())        + " (: " + dictionary.getMinWordSizeWord()        + ", " + Convert.ToString(dictionary.getMinWordSizeIndex())        + ")\r\n");
                dictionaryTextBox.AppendText(".  : "    + Convert.ToString(dictionary.getMaxWordSize())        + " (: " + dictionary.getMaxWordSizeWord()        + ", " + Convert.ToString(dictionary.getMaxWordSizeIndex())        + ")\r\n");
                dictionaryTextBox.AppendText(".  : "  + Convert.ToString(dictionary.getMinDescriptionSize()) + " (: " + dictionary.getMinDescriptionSizeWord() + ", " + Convert.ToString(dictionary.getMinDescriptionSizeIndex()) + ")\r\n");
                dictionaryTextBox.AppendText(".  : " + Convert.ToString(dictionary.getMaxDescriptionSize()) + " (: " + dictionary.getMaxDescriptionSizeWord() + ", " + Convert.ToString(dictionary.getMaxDescriptionSizeIndex()) + ")\r\n");
                StreamWriter streamWriter = new StreamWriter(Path.GetDirectoryName(openFileDialog.FileName) + '\\' + "report.txt", false, Encoding.Default);
                streamWriter.Write(dictionaryTextBox.Text);
                streamWriter.Close();
            }
        }

        private void exitMenuItem_Click(object sender, System.EventArgs e) {
            Close();
        }

    }

}
