package DreamBookMIDlet.Dictionary;

import DreamBookMIDlet.*;
import java.io.*;

public class Words {
    
    private static final String fileName = "/DreamBookMIDlet/Data/Words.txt";
    private static final int fileSize = 10365;
    private WordsOffsets wordsOffsets;
    private String words;
    
    public Words() {
        wordsOffsets = new WordsOffsets();
        try {
            char[] chars = new char[fileSize];
            byte[] buffer = new byte[fileSize];
            DataInputStream dataInputStream = new DataInputStream(Class.forName("java.lang.Class").getResourceAsStream(fileName));
            dataInputStream.read(buffer);
            dataInputStream.close();
            System.gc();
            for (int i = 0; i < fileSize; i++) {
                chars[i] = CharSets.CP1251[buffer[i] & 0xFF];
            }
            words = new String(chars);
        }
        catch (Exception E) {
        }
    }
    
    public String getWord(int index) {
        int offset0 = wordsOffsets.getOffset(index);
        int offset1 = wordsOffsets.getOffset(index + 1);
        return words.substring(offset0, offset1 - 1);
    }
    
    public int[] searchWords(String word) {
        int[] searchedWordsIndexes = null;
        int currentOffset = -1;
        while ((currentOffset = words.indexOf(word, currentOffset + 1)) != -1) {
            int index = wordsOffsets.getIndex(currentOffset);
            if (searchedWordsIndexes != null) {
                int[] tempSearchedWordsIndexes = new int[searchedWordsIndexes.length + 1];
                System.arraycopy(searchedWordsIndexes, 0, tempSearchedWordsIndexes, 0, searchedWordsIndexes.length);
                tempSearchedWordsIndexes[searchedWordsIndexes.length] = index;
                searchedWordsIndexes = tempSearchedWordsIndexes;
                System.gc();
            }
            else {
                searchedWordsIndexes = new int[1];
                searchedWordsIndexes[0] = index;
            }
        }
        return searchedWordsIndexes;
    }
    
}
