package DreamBookMIDlet;

import DreamBookMIDlet.Dictionary.*;
import javax.microedition.lcdui.*;

public class Main extends Form implements CommandListener {
    
    private Command decodeCommand = new Command("",       Command.SCREEN, 0);
    private Command helpCommand   = new Command("",      Command.SCREEN, 1);
    private Command aboutCommand  = new Command(" ", Command.SCREEN, 2);
    private Command exitCommand   = new Command("",       Command.SCREEN, 3);
    private TextField searchTextField = new TextField(":", "", 256, TextField.ANY);
    private Dictionary dictionary = new Dictionary();
    
    public Main() {
        super("");
        dictionary = new Dictionary();
        append(searchTextField);
        addCommand(decodeCommand);
        addCommand(helpCommand);
        addCommand(aboutCommand);
        addCommand(exitCommand);
        setCommandListener(this);
    }
    
    public Dictionary getDictionary() {
        return dictionary;
    }
    
    public void commandAction(Command command, Displayable displayable) {
        if (command == decodeCommand) {
            int[] searchedWordsIndexes = dictionary.searchWords(searchTextField.getString());
            if (searchedWordsIndexes != null) {
                DreamBookMIDlet.display.setCurrent(new SearchedWordsList(searchedWordsIndexes));
            }
            else {
                DreamBookMIDlet.display.setCurrent(new WordNotFoundForm());
            }
        }
        else if (command == helpCommand) {
            DreamBookMIDlet.display.setCurrent(new HelpForm());
        }
        else if (command == aboutCommand) {
            DreamBookMIDlet.display.setCurrent(new AboutForm());
        }
        else if (command == exitCommand) {
            DreamBookMIDlet.midlet.destroyApp(false);
        }
    }
    
}
